#include<stdio.h>
#include<stdlib.h>
#include<string.h>

struct drvo{
	char boja[10];
	char oblik[10];
	int balans;
	struct drvo * levi,* desni;
};


#define novi(x) x=(struct drvo *)malloc(sizeof(struct drvo))

int dubina(struct drvo*p){
	int dl=0,dd=0;
	if(p){
		if(p->levi)  dl=dubina(p->levi);
		if(p->desni) dd=dubina(p->desni);
		if(dl>dd) return ++dl;
		else return ++dd;
	}
	else return 0;
}


void lrotacija(struct drvo **t){
	struct drvo *poml,*pomd;
	poml=*t;
	pomd=poml->desni;
	poml->desni=pomd->levi;
	pomd->levi=poml;
	*t=pomd;
	poml->balans=dubina(poml->desni)-dubina(poml->levi);
	pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
}

void drotacija(struct drvo**t){
	struct drvo *poml,*pomd;
	pomd=*t;
	poml=pomd->levi;
	pomd->levi=poml->desni;
	poml->desni=pomd;
	*t=poml;
	poml->balans=dubina(poml->desni)-dubina(poml->levi);
	pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
}
int poredi(char * boja){
	if(strcmp(boja,"zlatna")==0) return 1;
	if(strcmp(boja,"crvena")==0) return 0;
	if(strcmp(boja,"srebrna")==0) return (-1);
}

int proveri(char * oblik){
	if(strcmp(oblik,"kocka")==0) return 1;
	if(strcmp(oblik,"sfera")==0) return 0;
}

int dodaj(struct drvo **p,char * boj,char * obl){
	int inkrement,rezultat=0;
	struct drvo *t=*p;
	if(t==NULL){
		novi(t);
		if(t==NULL){
			printf("Greska pri alokaciji memorije!\n");
			exit(0);
		}
	strcpy(t->boja,boj);
	strcpy(t->oblik,obl);
	t->levi=t->desni=NULL;
	t->balans=0;
 rezultat=1;
}
else{
	if(((poredi(boj)>poredi(t->boja))&& (proveri(obl)>proveri(t->oblik) )))
	inkrement=dodaj(&(t->desni),boj,obl);
	else 
	inkrement=-dodaj(&(t->levi),boj,obl);
	if((poredi(boj)==poredi(t->boja))&&(proveri(obl)==proveri(t->oblik)))
	inkrement=dodaj(&(t->desni),boj,obl);

	
	if(inkrement!=0 && t->balans!=0){
		if(t->balans<-1){
			if(t->levi->balans<0) drotacija(&t);
			else{lrotacija(&(t->levi));drotacija(&t);}}
			if(t->balans>1){
				if(t->desni->balans>0) lrotacija(&t);
				else{drotacija(&(t->desni));lrotacija(&t);}}
			else rezultat=1;
		}
	}
	*p=t;
	return rezultat;
}

		
		
struct drvo * form(){
	struct drvo *p;
	p=NULL;
	int n,i;
	char boj[50],obl[50];
	printf("Unesite broj ukrasa:\n");
	scanf("%d",&n);
	for(i=0;i<n;i++){
		printf("Unesite boju:\n");
		scanf("%s",boj);
		printf("Unesite oblik:\n");
		scanf("%s",obl);
		dodaj(&p,boj,obl);
	
	}
	return p;
	
}
void brisi(struct drvo *p,struct drvo **q,char * obl){
	if(p){
		if(strcmp(obl,p->oblik)!=0){
			dodaj(q,p->boja,p->oblik);
			brisi(p->levi,q,obl);
			brisi(p->desni,q,obl);
		}
		else{
			brisi(p->levi,q,obl);
			brisi(p->desni,q,obl);
		}
	}
	else return;
}

			
	
void ispis(struct drvo *p){
	if(p){
		if(p->levi) ispis(p->levi);
		printf("%s\t%s\t%d\n",p->boja,p->oblik,p->balans);
		if(p->desni) ispis(p->desni);
	}
}

main(){
	struct drvo*p,*q=NULL;
	p=form();
	ispis(p);
	printf("\n\n");
	printf("Oblik ukrasa na vrhu jelke je:\n");
	printf("%s\n",p->oblik);
	printf("\n\n");
	brisi(p,&q,p->oblik);
	ispis(q);
	
	
}
