#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct drvo{
        char boja_u[20];
        char oblik[20];
        int boja;
        struct drvo *levi, *desni, *roditelj;
};

enum{CRVENA,CRNA};

#define novi(x) x=(struct drvo*)malloc(sizeof(struct drvo))

void bojefix(struct drvo**,struct drvo*);

int provera(char a[20])
{
        if(strcmp(a,"zlatna")) return 1;
        if(strcmp(a,"crvena")) return 0;
        if(strcmp(a,"srebrna")) return -1;
        if(strcmp(a,"sfera")) return 1;
        else return 0;
}

void ispis(struct drvo *p)
{
        if(p)
        {
                ispis(p->levi);
                printf("%s",p->boja_u);
                printf("%s",p->oblik);
                if(p->boja==CRVENA) printf("(CRVENA)");
                else printf("(CRNA)");
                ispis(p->levi);
        }
}

void lrotacija(struct drvo **p)
{
        struct drvo *x, *y;
        
        x=*p;
        y=x->desni;
        x->desni=y->levi;
        if(y->levi) y->levi->roditelj=x;
        y->roditelj=x->roditelj;
        if(x->roditelj)
        if(x==x->roditelj->levi) x->roditelj->levi=y;
        else x->roditelj->levi=y;
        y->levi=x;
        x->roditelj=y;
        *p=y;
}

void drotacija(struct drvo **p)
{
        struct drvo *x, *y;
        
        x=*p;
        y=x->levi;
        x->levi=y->desni;
        if(y->desni) y->desni->roditelj=x;
        y->roditelj=x->roditelj;
        if(x->roditelj)
        if(x==x->roditelj->levi) x->roditelj->levi=y;
        else x->roditelj->levi=y;
        y->desni=x;
        x->roditelj=y;
        *p=y;
}

void dodaj(struct drvo **p, struct drvo *k)
{
        struct drvo *x, *y=NULL;
        
        x=*p;
        while(x)
        {
                y=x;
                if(provera(x->boja_u)>provera(k->boja_u)) x=x->levi;
                else if(provera(x->boja_u)<provera(k->boja_u)) x=x->desni;
                        else if(provera(x->boja_u)==provera(k->boja_u))
                        {
                                if(provera(x->oblik)>provera(k->oblik)) x=x->levi;
                                else if(provera(x->oblik)>provera(k->oblik)) x=x->desni;
                        }
                        else x=x->desni;
        }
        k->roditelj=y->roditelj;
        if(!y) (*p)=k;
        else if(y==y->roditelj->levi) y->roditelj->levi=k;
        	else y->roditelj->desni=k;
        
        bojefix(p,k);
}

struct drvo *form(void)
{
	struct drvo *p=NULL, *temp;
	char s[20];
	int i,n;
	
	scanf("%d",&n);
	getchar();
	
	for(i=0;i<n;i++)
	{
		novi(temp);
		gets(s);
		strtok(s,"\n");
		strcpy(temp->boja_u,s);
		gets(s);
		strtok(s,"\n");
		strcpy(temp->oblik,s);
		temp->boja=CRVENA;
		dodaj(&p,temp);
	}
	return p;
}

void bojefix(struct drvo **p, struct drvo *k)
{
	struct drvo *x, *y;
	
	while((k->roditelj) && (k->roditelj->boja==CRVENA))
	{
		if(k->roditelj==k->roditelj->roditelj->levi)
		{
			y=k->roditelj->roditelj->desni;
			if((y) && (y->roditelj->boja==CRVENA))
			{
				y->boja=CRNA;
				k->roditelj->boja=CRNA;
				k->roditelj->roditelj->boja=CRVENA;
				k=k->roditelj->roditelj;
			}
			else
			{
				if(k==k->roditelj->desni)
				{
					k=k->roditelj;
					lrotacija(&k);
					if(!k->roditelj) (*p)=k;
					k=k->levi;
				}
				k->roditelj->boja=CRNA;
				k->roditelj->roditelj->boja=CRVENA;
				x=k->roditelj->roditelj;
				drotacija(&x);
				if(!x->roditelj) (*p)=k;
			}
		}
		else
		{
			y=k->roditelj->roditelj->levi;
			if((y) && (y->roditelj->boja==CRVENA))
			{
				y->boja=CRNA;
				k->roditelj->boja=CRNA;
				k->roditelj->roditelj->boja=CRVENA;
				k=k->roditelj->roditelj;
			}
			else
			{
				if(k==k->roditelj->levi)
				{
					k=k->roditelj;
					drotacija(&k);
					if(!k->roditelj) (*p)=k;
					k=k->desni;
				}
				k->roditelj->boja=CRNA;
				k->roditelj->roditelj->boja=CRVENA;
				x=k->roditelj->roditelj;
				lrotacija(&x);
				if(!x->roditelj) (*p)=k;
			}
		}
	}
	(*p)->boja=CRNA;
}

void obrisi(struct drvo **p, struct drvo *q, char a[20])
{
	struct drvo *temp;
	
	if(q)
	if(q->oblik!=a)
	{
		novi(temp);
		strcpy(temp->oblik,q->oblik);
		strcpy(temp->boja_u,q->boja_u);
		temp->boja=CRVENA;
		temp->levi=temp->desni=temp->roditelj=NULL;
		dodaj(&q,temp);
		obrisi(p,q->levi,a);
		obrisi(p,q->desni,a);
	}
	else
	{
		obrisi(p,q->levi,a);
		obrisi(p,q->desni,a);
	}
	else return;
}

int levo_desno(struct drvo *p, char a[20], int *k)
{
	if(p)
	{
	levo_desno(p->levi, a, k);
	if(!strcmp(p->boja_u,a)) (*k)++;
	levo_desno(p->desni, );
	}
}

main()
{
        struct drvo *p, *q;
        int p1=0,p2=0;
       	
       	p=form();
       	ispis(p);
       	
       	printf("%s",p->oblik);
       	obrisi(&q,p,p->oblik);
       	
       	ispis(q);
       	
       	printf("%s",q->boja_u);
       	
       	levo_desno(q->levi,q->boja_u,&p1);
       	levo_desno(q->desni,q->boja_u,&p2);
       	
       	if(p1>p2) printf("Vise u levom!");
       	else if(p1<p2) printf("Vise u desnom!");
       	else printf("Jednako!");
}





















