#include<stdio.h>
#include<string.h>
#include<stdlib.h>

typedef struct cvor cvor;
struct cvor{
		char *boja;
		char *oblik;
		int balans;
		cvor *levi,*desni;
		};
	
cvor *alociraj()
{
		cvor *temp=(cvor *)malloc(sizeof(cvor));
		return temp;
}

int dubina(cvor *p)
{
		int dl=0,dd=0;
		
		if(p)
		{
				if(p->levi) dl=dubina(p->levi);
				if(p->desni) dd=dubina(p->desni);
				if(dl>dd) return dl++;
				else return dd++;
		}
		else return 0;
}

void lrotacija(cvor **p)
{
	cvor *poml,*pomd;
	poml=(*p);
	pomd=poml->desni;
	poml->desni=pomd->levi;
	pomd->levi=poml;
	(*p)=pomd;
	
	poml->balans=dubina(poml->desni)-dubina(poml->levi);
	pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
}

void drotacija(cvor **p)
{
	cvor *poml,*pomd;
	pomd=(*p);
	poml=pomd->levi;
	pomd->levi=poml->desni;
	poml->desni=pomd;
	(*p)=poml;
	
	poml->balans=dubina(poml->desni)-dubina(poml->levi);
	pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
}

void upis(cvor **p)
{
		cvor *pom=(*p),*temp;
		int i,n;
		char *boja,*oblik;
		printf("unesite n\n");
		scanf("%d",&n);
		for (i = 0; i < n; i++)
		{
			getchar();
			printf("unesite boju\n");
			gets(boja);
			printf("unesite oblik\n");
			gets(oblik);
			
			temp=alociraj();
			temp->levi=temp->desni=NULL;
			
			temp->boja=(char *)malloc(strlen(boja+1)*sizeof(char));
			temp->oblik=(char *)malloc(strlen(oblik+1)*sizeof(char));
			
			
			strcpy(temp->boja,boja);
			strcpy(temp->oblik,oblik);
			
			dodaj(&pom,temp);
		}
		(*p)=pom;
}
int bboje(char *a,char *b)
{
		int x,y;
		if(strcmp(a,"srebrna\n")==0) x=1;
		if(strcmp(a,"crvena\n")==0) x=2;
		if(strcmp(a,"zlantna\n")==0) x=3;
		
		if(strcmp(b,"srebrna\n")==0) y=1;
		if(strcmp(b,"crvena\n")==0) y=2;
		if(strcmp(b,"zlantna\n")==0) y=3;
		
		if(x<y) return 1;
		else return 0;
}

int ooblik(char *a,char *b)
{
		int x,y;
		if(strcmp(a,"sfera\n")==0) x=1;
		if(strcmp(a,"kocka\n")==0) x=2;
	
		
		if(strcmp(b,"sfera\n")==0) x=1;
		if(strcmp(b,"kocka\n")==0) x=2;
		
		if(x<y) return 1;
		else return 0;
}

int dodaj(cvor **p,cvor *temp)
{
		int rez=0,inkrement;
		cvor *pom=(*p);
		
		if(pom==NULL)
		{
				pom=temp;
				pom->balans=0;
				rez=1;
		}
		else
		{
			if(bboje(pom->boja,temp->boja)) inkrement=-dodaj(&(pom->levi),temp);
			else inkrement=dodaj(&(pom->desni),temp);
			
			pom->balans=pom->balans+inkrement;
			
			if((pom->balans!=0)&&(inkrement!=0))
			{
				if(pom->balans<-1)
				{
						if(pom->levi->balans<0) drotacija(&pom);
						else
						{
								lrotacija(&(pom->levi));
								drotacija(&pom);
						}
				}
				if(pom->balans>1)
				{
				if(pom->desni->balans>0) lrotacija(&pom);
						else
						{
								drotacija(&(pom->desni));
								lrotacija(&pom);
						}
				}
				else rez=1;
			}
	if(strcmp(pom->boja,temp->boja)==0){
				
			if(ooblik(pom->boja,temp->boja)) inkrement=-dodaj(&(pom->levi),temp);
			else inkrement=dodaj(&(pom->desni),temp);
			
			pom->balans=pom->balans+inkrement;
			
			if((pom->balans!=0)&&(inkrement!=0))
			{
				if(pom->balans<-1)
				{
						if(pom->levi->balans<0) drotacija(&pom);
						else
						{
								lrotacija(&(pom->levi));
								drotacija(&pom);
						}
				}
				if(pom->balans>1)
				{
				if(pom->desni->balans>0) lrotacija(&pom);
						else
						{
								drotacija(&(pom->desni));
								lrotacija(&pom);
						}
				}
				else rez=1;
			}
	}
		}
		(*p)=pom;
		return rez;
}

void ispis(cvor *p)
{
		if(p)
		{
				if(p->levi) ispis(p->levi);
				printf("%s\t%s\t%d\n",p->boja,p->oblik,p->balans);
				if(p->desni) ispis(p->desni);
		}
}

void brisi(cvor *p,cvor *vrh,cvor **q)
{
		if(strcmp(p->oblik,vrh->oblik))
		{		
				p->levi=NULL;
				p->desni=NULL;
				dodaj(&(*q),p);
		}
		if(p->levi) brisi(p->levi,vrh,&(*q));
		if(p->desni) brisi(p->desni,vrh,&(*q));
}

int broj(cvor *p,cvor *vrh)
{
		static x=0;
		
		if(strcmp(p->boja,vrh->boja)==0) x++;
		
		if(p->levi) x=broj(p->levi,vrh);
		if(p->desni) x=broj(p->desni,vrh);
		
		return x;
}
main()
{
		cvor *radi=NULL,*q=NULL,*vrh=NULL;
		int x,y;
		upis(&radi);
		ispis(radi);
		//vrh=radi;
		//printf("Oblik navrhu jelke je %s",vrh->oblik);
		
		//brisi(radi,vrh,&q);
		//ispis(q);
		
		//printf("boja navrhu jelke je %s",vrh->boja)
		
		//x=broj(radi->levi,vrh);
		//y=broj(radi->desni,vrh);
		
		//if(x<y) printf("vise ima u levoj");
		//else printf("vise ima u desnoj");		
}
