#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct drvo_s
{
	char *boja;
	char *oblik;
	int balans;
	struct drvo_s *levi,*desni;
	
}drvo;

#define novi(x) x=(drvo *)malloc(sizeof(drvo))


int dubina(drvo *p)
{
	int dl=0,dd=0;
	if(p)
		{
			if (p->levi) dl=dubina(p->levi);
			if (p->desni) dd=dubina(p->desni);
			if (dl>dd) return ++dl;
			else return ++dd;
		}
		else return 0;
}

void lrotacija(drvo **p)
{
	drvo *poml,*pomd;
	poml = *p;
	pomd = poml->desni;
	poml->desni = pomd->levi;
	pomd->levi = poml;
	*p=pomd;
	poml->balans=dubina(poml->desni)-dubina(poml->levi);
	pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
}


void drotacija(drvo **p)
{
	drvo *poml,*pomd;
	pomd = *p;
	poml = pomd->levi;
	pomd->levi = poml->desni;
	poml->desni= pomd;
	*p=poml;
	poml->balans=dubina(poml->desni)-dubina(poml->levi);
	pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
}

int uporedib(char *boja, char *boja1)
{
	if(strcmp(boja,"zlatna")==0) return 1;
	
	else if((strcmp(boja,"crvena")==0) && ((strcmp(boja1,"crvena")) || (strcmp(boja1,"srebrna"))))  return 1;
	else if((strcmp(boja,"crvena")==0) && (strcmp(boja1,"crvena")==0)) return 1 ;
	else return 0;
	
}



int dodaj(drvo **p,char *boja, char *oblik)
{
	int inkrement, rezultat;
	
	drvo *pom=*p;
	rezultat=0;
	
	if(pom==NULL)
	{
		novi(pom);
		if(!pom)
		{
			printf("Greska pri alokaciji memorije");
			exit(0);
		}
		
		pom->boja=(char *)malloc(strlen(boja+1));
		strcpy(pom->boja,boja);
		pom->oblik=(char *)malloc(strlen(oblik+1));
		strcpy(pom->oblik,oblik);
		pom->levi=pom->desni=NULL;
		pom->balans=0;
		rezultat=1;
	}
	else
	{
		if(uporedib(boja,pom->boja) && (strcmp(oblik,pom->oblik))) inkrement=dodaj(&(pom->desni),boja,oblik);
		else inkrement=-dodaj(&(pom->levi),boja,oblik);
		pom->balans+=inkrement;
		if(inkrement!=0 && pom->balans!=0)
		{
			if(pom->balans<-1)
			{
				if(pom->levi->balans<0) drotacija(&pom);
				else
				{
					lrotacija(&(pom->levi)); drotacija(&pom);
				}
			
			}
			else if(pom->balans>1)
			{
				if(pom->desni->balans>0) lrotacija(&pom);
				else
				{
					drotacija(&(pom->desni)); lrotacija(&pom);
				}
			}
			else rezultat=1;
		}
	}
	
	*p=pom;
	return rezultat;
}

void brisi(drvo *p, drvo **q, char *oblik)
{
	if(p)
	{
		brisi(p->levi,q, oblik);
		if(strcmp(p->oblik,oblik)!=0)
		dodaj(q,p->boja,p->oblik);
		brisi(p->desni,q,oblik);
	}
}
/*
int brojukrasa(drvo *p,char *boja)
{
	int l=0,d=0;
	if(p && strcmp(p->boja,boja)==0)
	{
		if(strcmp(p->boja,boja)==0)
		if(p->levi) l=brojukrasa(p->levi,boja);
		if(p->desni) d=brojukrasa(p->desni,boja);
		if(d>l) return 1;
		else  if(d<l) return -1;
		else return 0;
	}
}*/


void ispis(drvo *p)
{
	if (p) 
	{
		ispis(p->levi);
		printf("%s	 %s   %d\n",p->boja, p->oblik,p->balans);
		ispis(p->desni);
		
	}
	
	
}

main()
{
	drvo *p=NULL, *q=NULL;
	char boja[30],oblik[30];
	int n,i;
	
	printf("Unesi broj ukrasa za jelku: ");
	scanf("%d",&n);
	
	for (i = 0; i < n; i++)
	{
		printf("Unesi boju: ");
		scanf("%s",boja);
		printf("Unesi oblik: ");
		scanf("%s",oblik);
		dodaj(&p,boja,oblik);
	}
	printf("\n");
	
	ispis(p);
	printf("\n");
	
	printf("Unesi oblik za vrh jelke: ");
	scanf("%s",oblik);
	brisi(p,&q,oblik);
	ispis(q);
	//printf("Unesi boju ukrasa na vrhu: ");
	//scanf("%s",boja);
	//if((brojukrasa)==0) printf("Vise ima desno\n");
	//if((brojukrasa)==1) printf("Vise ima levo\n");
	//if((brojukrasa)==-1) printf(jednako\n");
}
