#include <stdio.h>
#include <stdlib.h>
#include <string.h>

enum{CRVENA,CRNA};

typedef struct _jelka
{
	char *bojaU;
	char *oblik; 
	int  boja;
	struct _jelka *levi,*desni,*roditelj;
}jelka;

int vece(char *prviB,char *drugiB,char *prviO,char *drugiO)
{
	int rez;
	
	if(strcmp(prviB,drugiB)==0)
		{
			if(strcmp(prviO,drugiO)==0) return 1;
			else{
				if(strcmp(prviO,"kocka")==0) return 1;
				else return 0;
			}
		}
	else{
		if(strcmp(prviB,"zlatna")==0) return 1;
		if((strcmp(prviB,"crvena")==0)&&(strcmp(drugiB,"srebrna")==0)) return 1;
		if((strcmp(prviB,"crvena")==0)&&(strcmp(drugiB,"zlatna")==0)) return 0;
		if(strcmp(prviB,"srebrna")==0) return 0;
			
	}
}

void bojefix(jelka **p,jelka *z){
	jelka *y;
	while((z->roditelj)&&(z->roditelj->boja==CRVENA)){
		if(z->roditelj==z->roditelj->levi){
			y=z->roditelj->roditelj->desni;
		
		if((y!=NULL)&&(y->boja==CRVENA)){
			y->boja=CRNA;
			z->roditelj->boja=CRNA;
			z=z->roditelj->roditelj;
			z->boja=CRVENA;
		}
		else{
			if(z=z->roditelj->desni){
				z=z->roditelj;
				lrotacija(&z);
				z=z->levi;
			}
			z->roditelj->boja=CRNA;
			z=z->roditelj->roditelj;
			z->boja=CRVENA;
			drotacija(&z);
			if(z->roditelj==NULL) *p=z;
		}
	}
	else{
		y=z->roditelj->roditelj->levi;
		if((y!=NULL)&&(y->boja==CRVENA)){
			z->roditelj->boja=CRNA;
			y->boja=CRNA;
			z=z->roditelj->roditelj;
			z->boja=CRVENA;
		}
		else{
			if(z=z->roditelj->levi){
				z=z->roditelj;
				drotacija(&z);
				z=z->desni;
			}
			z->roditelj->boja=CRNA;
			z=z->roditelj->roditelj;
			z->boja=CRVENA;
			lrotacija(&z);
			if(z->roditelj==NULL) *p=z;
		}
	}}
	(*p)->boja=CRNA;
}

void dodaj(jelka **p,jelka *z)
{
	jelka *tren,*pret;
	tren=*p;
	if(tren==NULL) *p=z;
	else{
		while(tren!=NULL){
			pret=tren;
			if(vece(z->bojaU,tren->bojaU,z->oblik,tren->oblik)==0) tren=tren->levi;
			else tren=tren->desni;
		}
		if(vece(z->bojaU,pret->bojaU,z->oblik,pret->oblik)==0) pret->levi=z;
			else pret->desni=z;
		z->roditelj=pret;
		bojefix(p,z);
	}
}

jelka *form(){
	jelka *koren,*z;
	int n,i;
	char s[50];
	printf("Unesi broj ukrasa\n");
	scanf("%d",&n);
	for(i=0;i<n;i++){
		z=(jelka*)malloc(sizeof(jelka));
		printf("unesi boju ukrasa\n");
		scanf("%s",s);
		z->bojaU=(char*)malloc(strlen(s)+1);
		strcpy(z->bojaU,s);
		printf("unesi oblik ukrasa\n");
		scanf("%s",s);
		z->oblik=(char*)malloc(strlen(s)+1);
		strcpy(z->oblik,s);
		dodaj(&koren,z);
	}
	return koren;
	
}


void lrotacija(jelka **p){
	jelka *t,*pom;
	t=*p;
	pom=t->desni;
	t->desni=pom->levi;
	if(pom->levi) pom->levi->roditelj=t;
	pom->roditelj=t->roditelj;
	if(t->roditelj)
	if(t==t->roditelj->levi) t->roditelj->levi=pom;
	else t->roditelj->desni=pom;
	pom->levi=t;
	t->roditelj=pom;
	*p=pom;
}
void drotacija(jelka **p){
	jelka *t,*pom;
	t=*p;
	pom=t->levi;
	t->levi=pom->desni;
	if(pom->desni) pom->desni->roditelj=t;
	pom->roditelj=t->roditelj;
	if(t->roditelj)
	if(t==t->roditelj->levi) t->roditelj->levi=pom;
	else t->roditelj->desni=pom;
	pom->levi=t;
	t->roditelj=pom;
	*p=pom;
}







void ispis(jelka *p){
	if(p!=NULL){
		ispis(p->levi);
		printf("boja ukrasa je %s, oblik je %s    ",p->bojaU,p->oblik);
		if(p->boja=CRNA) printf("(CRNA)\n");
		else printf("(CRVENA)\n");
		ispis(p->levi);
	}
}

main(){
	jelka *p=NULL;
	p=form();
	ispis(p);
	
}

