#include<stdio.h>
#include<string.h>
#include<stdlib.h>

typedef struct jelka
{
	char boja[20];
	char oblik[20];
	int balans;
	struct jelka *levi,*desni;
	
}DRVO;

#define novi(x) x=(DRVO *)malloc(sizeof(DRVO))

int dubina(DRVO *p)
{
	int dl,dd=0;
	if(p)
	{
		if(p->levi) dl=dubina(p->levi);
		if(p->desni) dd=dubina(p->desni);
		if(dl>dd) return ++dl;
		else return ++dd; 
		
	}
	else return 0;
	
}


void lrotacija(DRVO **p)
{
	DRVO *poml,*pomd;
	poml=*p;
	pomd=poml->desni;
	poml->desni=pomd->levi;
	pomd->levi=poml;
	*p=pomd;
	poml->balans=dubina(poml->desni) - dubina(poml->levi);
	pomd->balans=dubina(pomd->desni) - dubina(pomd->levi);
}

void drotacija(DRVO **p)
{
	DRVO *poml,*pomd;
	pomd=*p;
	poml=pomd->levi;
	pomd->levi=poml->desni;
	poml->desni=pomd;
	*p=poml;
	poml->balans=dubina(poml->desni) - dubina(poml->levi);
	pomd->balans=dubina(pomd->desni) - dubina(pomd->levi);
}



int oblik(char *oblik1,char *oblik2)
{
	if(strcmp(oblik1,oblik2)==0) return 1;
	if(strcmp(oblik1,"sfera")==0) return 0;
	else return 1;
	
}

int bojim(char *boja1,char * boja2,char *oblik1,char *oblik2)
{
	if(strcmp(boja1,boja2)==0 && oblik(oblik1,oblik2)==1 ) return 1;
	if(strcmp(boja1,boja2)==0 && oblik(oblik1,oblik2)==0 ) return 0;
	if(strcmp(boja1,"srebrna")==0) return 0;
	if(strcmp(boja1,"zlatna")==0) return 1;
	if(strcmp(boja1,"crvena")==0)
	{
		if(strcmp(boja2,"srebrna")==0) return 0;
		else return 1;
	} 
	
}



int dodaj(DRVO **p,char *boja,char *oblik)
{
	int inkrement;
	int rezultat=1;
	DRVO *t=*p;
	if(t==NULL)
	{
		novi(t);
		if(t==NULL) {
					  printf("Alokacija");
					  exit(1);
					}
			
			strcpy(t->boja,boja);
			strcpy(t->oblik,oblik);
			t->balans=0;
			t->levi=t->desni=NULL;
			rezultat=1;
			
			
	}
	else
	{
		if(bojim(boja,t->boja,oblik,t->oblik)==1) inkrement=dodaj(&(t->desni),boja,oblik);
		else inkrement=-dodaj(&(t->levi),boja,oblik);
		t->balans=+inkrement;
		
		if(t->balans !=0 && inkrement !=0)
		{
			if(t->balans < -1)
			{
				if(t->levi->balans < 0) {drotacija(&t);}
				else {
						lrotacija(&(t->levi));
						drotacija(&t);
					 }
			}
			else if(t->balans > 1)
			{
				if(t->desni->balans > 0) {lrotacija(&t);}
				else {
						drotacija(&(t->desni));
						lrotacija(&t);
					 }
			}
			else rezultat=1;
		}
		
		
	}
	*p=t;
	return rezultat;
	
}



void ispis(DRVO *p)
{
	if(p)
	{
		ispis(p->desni);
		printf("%s\t%s\t%d\n",p->boja,p->oblik,p->balans);
		ispis(p->levi);
		
	}
	
}

void brisanje(DRVO **t,DRVO *p,char *oblik)
{
	if(p)
	{
		if(strcmp(p->oblik,oblik)!=0)
		{
			dodaj(t,p->boja,p->oblik);
		}
		
		brisanje(&(*t),p->desni,oblik);	
		brisanje(&(*t),p->levi,oblik);
		
	}
	
}

int br;

void prebroj(DRVO *p,char *boja)
{
	if(p)
	{
		if(strcmp(boja,p->boja)==0) ++br;
		prebroj(p->desni,boja);
		prebroj(p->levi,boja);		
		
	}
}


main()
{
	DRVO *p=NULL;
	int n;
	scanf("%d",&n);
	int i;
	char boja[20];
	char oblik[20];
	for(i=0;i<n;i++)
	{
		scanf("%s%s",boja,oblik);
		dodaj(&p,boja,oblik);	
	}
	ispis(p);
	printf("Na vrhu jelke je: %s\t%s\t%d\n",p->boja,p->oblik,p->balans);
	DRVO *t=NULL;
	char pom[20];
	strcpy(pom,p->oblik);
	brisanje(&t,p,pom);
	printf("nakon brisanja je\n");
	ispis(t);
	printf("Boja na vrhu je: %s\n",t->boja);
	pom[20];
	strcpy(pom,p->boja);
	br=0;	
	prebroj(t->levi,pom);
	int x=br;
	br=0;
	prebroj(t->desni,pom);
	int x1=br;
	
	 if(x>x1) printf("Ima vise u levom podstabu");
	else if(x<x1)printf("Ima vise u desnom podstablu");
	else printf("Podjenako je");
}
