#include <stdio.h>
#include <stdlib.h>

enum {CRVENA, CRNA}

struct drvo
{
	
	char boja[10], oblik[10];
	struct drvo *roditelj, *levi,*desni;
};

#define novi(x) x=(struct drvo *)malloc(sizeof(struct drvo))


void lrotacija(struct drvo **t)
{
	struct drvo *x,*y;
	x=*t;
	y=x->desni;
	x->desni=y->levi;
	if(y->levi) y->levi->roditelj=x;
	y->roditelj=x->roditelj;
	if(x->roditelj)
		if(x==x->roditelj->levi) x->roditelj->levi=y;
		else x->roditelj->desni=y;
	y->levi=x;
	x->roditelj=y;
	*t=y;
}

void drotacija(struct drvo **t)
{
	struct drvo *x,*y;
	y=*t;
	x=y->levi;
	y->levi=x->desni;
	if(x->desni) x->desni->roditelj=y;
	x->roditelj=y->roditelj;
	if(y->roditelj)
		if(y==y->roditelj->levi) y->roditelj->levi=x;
		else y->roditelj->desni=x;
	x->desni=y;
	y->roditelj=x;
	*t=x;
}

void bojefix(struct drvo **p, struct drvo *z)
{
	struct drvo *y,*t;
	while((z->roditelj) && (z->roditelj->boja == CRVENA))
	{
		if(z->roditelj == z->roditelj->roditelj->levi)
		{
			y=z->roditelj->roditelj->desni;
			if((y) && (y->boja == CRVENA))
			{
				z->roditelj->boja=CRNA;
				y->boja=CRNA;
				z->roditelj->roditelj->boja=CRVENA;
				z=z->roditelj->roditelj;
			}
			else
			{
				if(z==z->roditelj->desni)
				{
					z=z->roditelj;
					lrotacija(&z);
					if(!z->roditelj) *p=z;
					z=z->levi;
				}
				
				z->roditelj->boja=CRNA;
				z->roditelj->roditelj->boja=CRVENA;
				t=z->roditelj->roditelj;
				drotacija(&t);
				if(!t->roditelj) *p=t;
			}
		}
		else
		{
			y=z->roditelj->roditelj->levi;
			if((y) && (y->boja == CRVENA))
			{
				z->roditelj->boja=CRNA;
				y->boja=CRNA;
				z->roditelj->roditelj->boja=CRVENA;
				z=z->roditelj->roditelj;
			}
			else
			{
				if(z==z->roditelj->levi)
				{
					z=z->roditelj;
					drotacija(&z);
					if(!z->roditelj) *p=z;
					z=z->desni;
				}
				z->roditelj->boja=CRNA;
				z->roditelj->roditelj->boja=CRVENA;
				t=z->roditelj->roditelj;
				lrotacija(&t);
				if(!t->roditelj) *p=t;
			}
		}
	}
	(*p)->boja=CRNA;
}

/* !!za ispravku!!
 * void dodaj(struct drvo **p, struct drvo *z)
{
	struct drvo *y,*x;
	x=*p;
	y=NULL;
	while(x)
	{
		x=y;
		if(x->boja[3]>=z->boja[3] && x->oblik[1]>=z->oblik[1]) x=x->levi;
		else x=x->desni;
	}
	z->roditelj=y;
	if(!y) *p=z;
	else
	{
		if(z->broj<y->broj) y->levi=z;
		else y->desni=z;
	}
	bojefix(p,z);
}*/

struct drvo * form()
{
	struct drvo *koren, *z;
	int n,i;
	char s[50];
	printf("Unesi broj stringova: \n");
	scanf("%d",&n);
	for(i=0;i<n;i++)
	{
		printf("Unesi string\n");
		scanf("%s",&s);
		novi(z);
		z->rec=(char *)malloc(strlen(s)+1);
		strcpy(z->rec,s);
		z->boja=CRVENA;
		z->levi=z->desni=z->roditelj=NULL;
		dodaj(&koren,z);
		k-=1;
	}
	return (koren);
}

void ispis(struct drvo *p)
{
	if(p!=NULL)
	{
		ispis(p->desni);
		printf("%s, ",p->rec);
		if(p->boja==CRVENA) printf("(crvena)\n");
		else printf("(crna)\n");
		ispis(p->levi);
	}
}

main()
{
	struct drvo *koren;
	int k;
	koren = form();
	ispis(koren);
}



