#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct ukras
{
	char boja[10];
	char oblik[10];
	int brojb;
	int balans;
	struct ukras *levi, *desni;
};

#define novi(x) x = (struct ukras *)malloc(sizeof(struct ukras))

int dodaj(struct ukras **, char [10] , char [10]);
void drotacija(struct ukras **);
void lrotacija(struct ukras **);
struct ukras *form();
void ispis(struct ukras *);
int boja(char [10]);
int dubina(struct ukras *);



int dodaj(struct ukras **p, char color[10], char shape[10])
{
	struct ukras *t;
	int rez, ink;
	t = *p;
	if(*p==NULL)
	{
		novi(t);
		strcpy(t->boja,color);
		strcpy(t->oblik,shape);
		t->brojb = boja(color);
		t->balans = 0;
		rez = 1;
	}
	else
	{
		if(boja(color) > t->brojb) ink = dodaj(&(t->desni),color,shape);
		
		else if(boja(color) < t->brojb) ink = -dodaj(&(t->levi),color,shape);
		
		else if(boja(color) == t->brojb)
		{
			if(!strcmp(t->oblik,shape)) ink = dodaj(&(t->desni),color,shape);
			else ink = -dodaj(&(t->levi),color,shape);
		}
		t->balans += ink;
		
		if((ink!=0) && (t->balans!=0))
		{
			if(t->balans < -1)
			{
				if(t->levi->balans < 0) drotacija(&t);
				else
				{
					lrotacija(&(t->desni));
					drotacija(&t);
				}
			}
			if(t->balans > 1)
			{
				if(t->desni->balans > 0) lrotacija(&t);
				else
				{
					drotacija(&(t->levi));
					lrotacija(&t);
				}
			}
			else rez = 0;
		}		
	}
	*p = t;
	return rez;
}

void drotacija(struct ukras **p)
{
	struct ukras *x, *y;
	y = *p;
	x = y->levi;
	y->levi = x->desni;
	x->desni = y;
	*p = x;
	x->balans = dubina(x->desni) - dubina(x->levi);
	y->balans = dubina (y->desni) - dubina(x->levi);
}

void lrotacija(struct ukras **p)
{
	struct ukras *x, *y;
	x = *p;
	y = x->desni;
	x->desni = y->levi;
	y->levi = x;
	*p = y;
	x->balans = dubina(x->desni) - dubina(x->levi);
	y->balans = dubina (y->desni) - dubina(x->levi);
}

int dubina(struct ukras *p)
{
	int dl = 0, dd = 0;
	if(p)
	{
		if(p->levi) dl = dubina(p->levi);
		if(p->desni) dd = dubina(p->desni);
		if (dl > dd) return ++dl;
		else return ++dd;
	}
}

void ispis(struct ukras *p)
{
	if(p)
	{
		ispis(p->levi);
		printf("boja: %s, oblik: %s, balans: %d\n",p->boja,p->oblik,p->balans);
		ispis(p->desni);
	}
}

struct ukras *form()
{
	struct ukras *koren;
	int n,i,a;
	char color[10],shape[10];
	koren = NULL;
	printf("unesite broj ukrasa\n");
	scanf("%d",&n);
	for(i = 0; i < n; i++)
	{		
		printf("unesite boju ukrasa\n");
		scanf("%s",color);
		printf("unesite oblik ukrasa\n");
		scanf("%s",shape);
		dodaj(&koren, color, shape);
	}
	return koren;
}

int boja(char color[10])
{
	if(!strcmp(color,"srebrna")) return 1;
	else if (!strcmp(color,"crvena")) return 2;
	else if (!strcmp(color,"zlatna")) return 3;
}

main()
{
	struct ukras *p;
	p = form();
	ispis(p);
	printf("boja ukrasa na vrhu jelke je %s\n",p->boja);
}	
	
