#include<stdio.h>
#include<stdlib.h>
#include<string.h>

enum{crvena,crna};

typedef struct jelka{
	char boja[20],oblik[20];
	int color;
	struct jelka *roditelj,*levi,*desni; }jelka;

#define novi(x) x=(jelka *)malloc(sizeof(jelka));

void lrotacija(jelka **t)
{
	jelka *x,*y;
	x=(*t);
	y=x->desni;
	x->desni=y->levi;
	if(y->levi) y->levi->roditelj=x;
	y->roditelj=x->roditelj;
	if(x->roditelj)
		if(x==x->roditelj->levi) x->roditelj->levi=y;
		else x->roditelj->desni=x;
	y->levi=x;
	x->roditelj=y;
	(*t)=y;
}	
void drotacija(jelka **t)
{
	jelka *x,*y;
	x=(*t);
	y=x->levi;
	x->levi=y->desni;
	if(y->desni) y->desni->roditelj=x;
	y->roditelj=x->roditelj;
	if(x->roditelj)
		if(x==x->roditelj->levi) x->roditelj->levi=y;
		else x->roditelj->desni=x;
	y->desni=x;
	x->roditelj=y;
	(*t)=y;
}	

int poredjenje(jelka *a,jelka *b)
{
	int p;
	char a1[20],b1[20],a2[20],b2[20];
	strcpy(a1,a->boja);
	strcpy(a2,a->oblik);
	strcpy(b1,b->boja);
	strcpy(b2,b->oblik);
	if((!strcmp(a1,"zlatna")) && ((!strcmp(b1,"crvena")) || (!strcmp(b1,"srebrna")))) return 1;
	if((!strcmp(a1,"crvena")) && (!strcmp(b1,"srebrna"))) return 1;
	if(!strcmp(a1,b1))
		if((!strcmp(a2,"kocka")) && (!strcmp(b2,"sfera"))) return 1;
	return 0;
}

void colorfix(jelka **p,jelka *z)
{
	jelka *y,*t;
	while((z->roditelj) && (z->roditelj->color==crvena))
	{
		if(z->roditelj==z->roditelj->roditelj->levi)
		{
			y=z->roditelj->roditelj->desni;
			if((y) && (y->color==crvena))
			{
				z->roditelj->color=crna;
				z->roditelj->roditelj->color=crvena;
				y->color=crna;
				z=z->roditelj->roditelj;
			}
			else
			{
				if(z==z->roditelj->desni)
				{
					z=z->roditelj;
					lrotacija(&z);
					if(!z->roditelj) (*p)=z;
					z=z->levi;
				}
				z->roditelj->color=crna;
				z->roditelj->roditelj->color=crvena;
				t=z->roditelj->roditelj;
				drotacija(&t);
				if(!t->roditelj) (*p)=t;
			}
		}
		else
		{
			y=z->roditelj->roditelj->levi;
			if((y) && (y->color==crvena))
			{
				z->roditelj->color=crna;
				z->roditelj->roditelj->color=crvena;
				y->color=crna;
				z=z->roditelj->roditelj;
			}
			else
			{
				if(z==z->roditelj->levi)
				{
					z=z->roditelj;
					drotacija(&z);
					if(!z->roditelj) (*p)=z;
					z=z->desni;
				}
				z->roditelj->color=crna;
				z->roditelj->roditelj->color=crvena;
				t=z->roditelj->roditelj;
				lrotacija(&t);
				if(!t->roditelj) (*p)=t;
			}
		}
	}
	(*p)->color=crna;
}

void dodaj(jelka **p,jelka *z)
{
	jelka *x,*y;
	x=(*p);
	y=NULL;
	while(x)
	{
		y=x;
		if(poredjenje(x,z)) x=x->levi;
		else x=x->desni;
	}
	z->roditelj=y;
	if(!y) (*p)=z;
	else
	{
		if(poredjenje(y,z)) y->levi=z;
		else y->desni=z;
	}
	colorfix(p,z);
}

jelka *form(void)
{
	jelka *p=NULL,*pom;
	int i,n;
	char s[20];
	printf("unesite broj ukrasa na jelci:\n");
	scanf("%d",&n);
	getchar();
	printf("unosite redom ukrase:\n");
	for(i=0;i<n;i++)
	{
		novi(pom);
		pom->levi=pom->desni=NULL;
		pom->color=crvena;
		gets(s);
		strtok(s,"\n");
		strcpy(pom->boja,s);
		gets(s);
		strtok(s,"\n");
		strcpy(pom->oblik,s);
		dodaj(&p,pom);
	}
	return p;
}
void ispis(jelka *p)
{
	if(p)
	{
		ispis(p->levi);
		printf("%s %s ",p->boja,p->oblik);
		if(p->color==crvena) printf("crvena\n");
		else printf("crna\n");
		ispis(p->desni);
	}
}

void obrisi(jelka **b,jelka *p,char *s)
{
	jelka *pom;
	if(p)
	{
		if(strcmp(p->oblik,s))
		{
			novi(pom);
			pom->levi=pom->desni=pom->roditelj=NULL;
			pom->color=crvena;
			strcpy(pom->boja,p->boja);
			strcpy(pom->oblik,p->oblik);
			dodaj(b,p);
			obrisi(b,p->levi,s);
			obrisi(b,p->desni,s);
		}
		else
		{
			obrisi(b,p->levi,s);
			obrisi(b,p->desni,s);
		}
	}
	else return;
}

void broj(int *br,jelka *p,char *s)
{
	if(p)
	{
		broj(br,p->levi,s);
		if(!strcmp(s,p->boja)) (*br)++;
		broj(br,p->desni,s);
	}
}

void main()
{
	jelka *p,*b=NULL;
	int br1=0,br2=0;
	p=form();
	ispis(p);
	printf("oblik ukrasa na vrhu jelke %s\n",p->oblik);
	obrisi(&b,p,p->oblik);
	ispis(b);
	printf("boja ukrasa na vrhu jelke %s\n",b->boja);
	broj(&br1,b->levi,b->boja);
	broj(&br2,b->desni,b->boja);
	if(br1>br2) printf("na levoj strani ih ima vise\n");
	else if(br1<br2) printf("na desnoj strani ih ima vise\n");
	else printf("ima ih isto\n");
}
