#include<stdio.h>
#include<string.h>
#include<stdlib.h>

struct drvo
{
	char boja[20];
	char oblik[20];
	int balans;
	struct drvo *levi, *desni;
};

#define novi(x) x=(struct drvo*)malloc(sizeof(struct drvo))

int dubina(struct drvo *p)
{
	int dd=0,dl=0;
	if(p)
	{
		if(p->levi) dl=dubina(p->levi);
		if(p->desni) dd=dubina(p->desni);
		if(dl>dd) return ++dl;
		else return ++dd;
	}
	else return 0;
}

void Lrotacija(struct drvo **t)
{
	struct drvo *poml,*pomd;
	poml=*t;
	pomd=poml->desni;
	
	poml->desni=pomd->levi;
	pomd->levi=poml;
	*t=pomd;
	
	poml->balans=dubina(poml->desni)-dubina(poml->levi);
	pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
}

void Drotacija(struct drvo **t)
{
	struct drvo *poml,*pomd;
	pomd=*t;
	poml=pomd->levi;
	
	pomd->levi=poml->desni;
	poml->desni=pomd;
	*t=poml;
	
	poml->balans=dubina(poml->desni)-dubina(poml->levi);
	pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
}

int uredi(struct drvo *p,char boja[20],char oblik[20])
{
	int levo,levo1,desno,desno1;
	if(!strcmp(p->boja,"crvena")) levo=0;
	else if(!strcmp(p->boja,"srebrna")) levo=1;
	else if(!strcmp(p->boja,"zlatna")) levo=2;
	
	if(!strcmp(p->oblik,"sfera")) levo1=0;
	else if (!strcmp(p->oblik,"kocka")) levo1=1;
	
	if(!strcmp(p->boja,"crvena")) desno=0;
	else if(!strcmp(p->boja,"srebrna")) desno=1;
	else if(!strcmp(p->boja,"zlatna")) desno=2;
	
	if(!strcmp(p->oblik,"sfera")) desno1=0;
	else if (!strcmp(p->oblik,"kocka")) desno1=1;
	
	if(levo<desno || (levo==desno && levo1<=desno1)) return 1;
	else return 0;
}

int dodaj(struct drvo **q, char boja[20], char oblik[20])
{
	int inkrement, rezultat=0;
	struct drvo *p=*q;
	if(p==NULL)
	{
		novi(p);
		if(!p) perror("Greska pri alokaciji memorije\n");
		strcpy(p->boja,boja);
		strcpy(p->oblik,oblik);
		p->levi=p->desni=NULL;
		p->balans=0;
		rezultat=1;		
	}
	else
	{
		if(uredi(p,boja,oblik)) inkrement=dodaj(&(p->desni),boja,oblik);
		else inkrement=-dodaj(&(p->levi),boja,oblik);
		p->balans+=inkrement;
		if(p->balans!=0 && inkrement!=0)
		{
			if(p->balans<-1)
			{
				if(p->levi->balans<0) Drotacija(&p);
				else
				{
					Lrotacija(&(p->levi));
					Drotacija(&p);
				}
			}
			else if(p->balans>1)
			{
				if(p->desni->balans>0) Lrotacija(&p);
				else
				{
					Drotacija(&(p->desni));
					Lrotacija(&p);
				}
			}
			else rezultat=1;
		}
	}
	*q=p;
	return rezultat;
}

void ispis(struct drvo *p)
{
	if(p)
	{
		ispis(p->levi);
		printf("%s\t%s\t(%d)\n",p->boja,p->oblik,p->balans);
		ispis(p->desni);
	}
}

main()
{
	int i,n;
	char boja[20],oblik[20];
	struct drvo *koren=NULL,*pom=NULL;
	scanf("%d",&n);
	getchar();
	
	for(i=0;i<n;i++)
	{
		gets(boja);
		gets(oblik);
		dodaj(&koren,boja,oblik);
	}
	printf("Jelkica:\n");
	ispis(koren);
	printf("vrh: %s \n",koren->oblik);
}
