#include <stdio.h>
#include <stdlib.h>
#include <string.h>

enum{CRNA,CRVENA};

struct drvo 
{
	struct drvo *levi,*desni,*roditelj;
	char *boja;
	char *oblik;
	int bojacvora;
};

typedef struct drvo stablo;
#define novi(x) x=(stablo *)malloc(sizeof(stablo));
//==========rotacija stabla u levo===========//
void lrotacija(stablo **p)
{
	stablo *pom,*pom1;
	pom=*p;
	pom1=pom->desni;
	pom->desni=pom1->levi;
	if(pom1->levi) pom1->levi->roditelj=pom;
	pom1->roditelj=pom->roditelj;
		if(pom->roditelj)
			if(pom==pom->roditelj->levi)
			pom->roditelj->levi=pom1;
			else pom->roditelj->desni=pom1;
			pom1->levi=pom;
			pom->roditelj=pom1;
			*p=pom1;
}
//===========rotacija stabla u desno==========//
void drotacija(stablo **p)
{
	stablo *pom,*pom1;
	pom=*p;
	pom1=pom->levi;
	pom->levi=pom1->desni;
	if(pom1->desni) pom1->desni->roditelj=pom;
	pom1->roditelj=pom->roditelj;
		if(pom->roditelj)
			if(pom==pom->roditelj->desni)
			pom->roditelj->desni=pom1;
			else pom->roditelj->levi=pom1;
			pom1->desni=pom;
			pom->roditelj=pom1;
			*p=pom1;
}
//========boje cvora============//
void bojefix(stablo **p,stablo *z)
{
	stablo *y,*t;
	while((z->roditelj) && (z->roditelj->bojacvora == CRVENA))
	{
		if(z->roditelj == z->roditelj->roditelj->levi)
		{
			y=z->roditelj->roditelj->desni;
			if((y) && (y->bojacvora == CRVENA))
			{
				z->roditelj->bojacvora=CRNA;
				y->bojacvora=CRNA;
				z->roditelj->roditelj->bojacvora=CRVENA;
				z=z->roditelj->roditelj;
			}
			else
			{
				if(z == z->roditelj->desni)
				{
					z=z->roditelj;
					lrotacija(&z);
					if(!z->roditelj) *p=z;
					z=z->levi;
				}
				z->roditelj->bojacvora=CRNA;
				z->roditelj->roditelj->bojacvora=CRVENA;
				t=z->roditelj->roditelj;
				drotacija(&t);
				if(!t->roditelj) *p=t;
			}
		}
		else
		{
			y=z->roditelj->roditelj->levi;
			if((y) && (y->bojacvora == CRVENA))
			{
				z->roditelj->bojacvora=CRNA;
				y->bojacvora=CRNA;
				z->roditelj->roditelj->bojacvora=CRVENA;
				z=z->roditelj->roditelj;
			}
			else
			{
				if(z == z->roditelj->levi)
				{
					z=z->roditelj;
					drotacija(&z);
					if(!z->roditelj) *p=z;
					z=z->desni;
				}
				z->roditelj->bojacvora=CRNA;
				z->roditelj->roditelj->bojacvora=CRVENA;
				t=z->roditelj->roditelj;
				lrotacija(&t);
				if(!t->roditelj) *p=t;
			}
		}
	}
	(*p)->bojacvora=CRNA;
}
//==========brisanje============//
/*
void brisi(stablo **p,stablo *z,char oblik[])
{
	stablo *pom;
	if(z!=NULL)
	if(strcmp(z->oblik,oblik) == 0)
	{
		brisi(p,z->levi,oblik);
		brisi(p,z->desni,oblik);
	}
	else
	{
		novi(pom);
		pom->boja = (char *)malloc(strlen(boja)+1);
		pom->oblik = (char *)malloc(strlen(oblik)+1);
		pom->boja=z->boja;
		pom->oblik=z->oblik;
		pom->levi=pom->desni=pom->roditelj=NULL;
		pom->bojacvora=CRVENA;
		dodaj(p,z);
		brisi(p,z->levi,oblik);
		brisi(p,z->desni,oblik);
	}
	else return;
}
*/
//===============================//

int bojaukrasa(stablo *p,char boja[])
{
	if((strcmp(p->boja,boja) ==0) && (strcmp(boja,"srebrna") ==0)) return 1;
	else if((strcmp(p->boja,boja) ==0) && (strcmp(boja,"crvena") ==0)) return 2;
	else if((strcmp(p->boja,boja) ==0) && (strcmp(boja,"zlatna") ==0)) return 3;
	else return;
}
//=============================//
int oblikukrasa(stablo *p,char oblik[])
{
	if((strcmp(p->oblik,oblik) ==0) && (strcmp(oblik,"sfera") ==0)) return 1;
	else if((strcmp(p->oblik,oblik) ==0) && (strcmp(oblik,"kocka") ==0)) return 2;
}
//==========dodavanje cvora u stablo==========//
void dodaj(stablo **p,stablo *z)
{
	stablo *pom,*pom1;
	pom=*p;
	pom1=NULL;
	while(pom!=NULL)
	{
		pom1=pom;
		if(z->boja < pom->boja) pom=pom->levi;
		else pom=pom->desni;
	}
	z->roditelj=pom1;
	if(!pom1)
	*p=z;
	else
	{
		if(z->boja < pom1->boja) pom1->levi=z;
		else pom1->desni=z;
	}
	bojefix(p,z);
}
//===========formiranje stabla==========//
stablo *form()
{
	stablo *p=NULL,*z;
	int n,i;
	char boja[100],oblik[100];
	
	printf("uneti broj ukrasa: ");
	scanf("%d",&n);
	getchar();
	for(i=0;i<n;i++)
	{
		novi(z);
		printf("uneti boju ukrasa: ");
		gets(boja);
		z->boja=(char *)malloc(strlen(boja)+1);
		strcpy(z->boja,boja);
		printf("uneti oblik ukrasa: ");
		gets(oblik);
		z->oblik=(char *)malloc(strlen(oblik)+1);
		strcpy(z->oblik,oblik);
		z->levi=z->desni=z->roditelj=NULL;
		z->bojacvora=CRVENA;
		dodaj(&p,z);
	}
	return p;
}
//===========stampanje=========//
void ispis(stablo *p)
{
	if(p!=NULL)
	{
		ispis(p->levi);
		printf("%s\t%s\t",p->boja,p->oblik);
		if(p->bojacvora == CRVENA) printf("(CRVENA)");
		else printf("(CRNA)");
		ispis(p->desni);
	}
	printf("\n");
}
//===========================//
main()
{
	stablo *p;
	p=form();
	ispis(p);
}


